import {makeAutoObservable} from "mobx";
import {http} from "../utils/http";

export class Partner {
    page = 0;
    pageSize = 10
    data = [];
    total_data = 0;
    filterCategory = null;
    visibleModalPartner = false;

    pageCategories = 0;
    pageSizeCategories = 10
    dataCategories = [];
    total_dataCategories = 0;

    pageSubCategories = 0;
    pageSizeSubCategories = 10
    dataSubCategories = [];
    total_dataSubCategories = 0;

    constructor(ctx) {
        this.ctx = ctx;
        makeAutoObservable(this);
    }

    async getData() {
        const response = await http.get(`/users/partner?page=${this.page}&pageSize=${this.pageSize}`);
        
        this.data = response.body.data.map((item, idx) => {
            item.key = idx;
            return item
        }) ?? []

        this.total_data = response.body.count ?? 0
    }

    async create(data) {
        const response = await http.post('/users/partner').send(data);
        await this.getData();
        return response;
    }

    async update(id, data) {
        const response = await http.put(`/users/partner/${id}`).send(data);
        await this.getData();
        return response;
    }

    // async updateStatus(id, data) {
    //     const response = await http.put(`/users/partner/${id}`).send(data);
    //     await this.getData();
    //     return response;
    // }

    async delete(id) {
        const response = await http.del(`/product/${id}`);
        await this.getData();
        return response;
    }

    async changeStatus(id, status) {
        const response = await http.get(`/users/partner/${id}/${status}`);
        await this.getData();
        return response;
    }

}


